package com.njcn.csdevice.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csdevice.api.CsUpgradeLogsFeignClient;
import com.njcn.csdevice.pojo.po.CsUpgradeLogs;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author caozehui
 * @data 2026-04-23
 */
@Slf4j
@Component
public class CsUpgradeLogsClientFallbackFactory implements FallbackFactory<CsUpgradeLogsFeignClient> {
    @Override
    public CsUpgradeLogsFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;

        return new CsUpgradeLogsFeignClient() {
            @Override
            public HttpResult add(CsUpgradeLogs csUpgradeLogs) {
                log.error("{}异常，降级处理，异常为：{}", "新增升级日志异常", cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Boolean> update(String devId, String code, Integer result) {
                log.error("{}异常，降级处理，异常为：{}", "修改升级日志", cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
